<template>
  <div class="catalog-viewer">
    <div :class="leftPageClass">
      <img :src="leftPageSrc" />
    </div>
    <div :class="rightPageClass">
      <img :src="rightPageSrc" />
    </div>
  </div>
</template>

<script lang="ts">
import { Options, Vue } from "vue-class-component";
import { PropType } from "vue";
import { Catalog } from "@/models/Catalog";

@Options({
  name: CatalogViewer.name,
  props: {
    catalog: Object as PropType<Catalog>,
    page: Number,
  },
  watch: {},
})
export default class CatalogViewer extends Vue {
  catalog!: Catalog;
  page!: number;

  /**
   * Must be PAIR and represent LEFT page number.
   * Be aware that LEGO catalogs covers are the page 1.
   */
  get leftPage(): number {
    return this.page % 2 === 0 ? this.page : this.page - 1;
  }

  get rightPage(): number {
    return this.leftPage + 1;
  }

  private pageToIndex(value: number): number | null {
    const index = value - 1;
    if (index < 0 || index >= this.catalog.pages.length) return null;
    return index;
  }

  get leftPageIndex(): number | null {
    return this.pageToIndex(this.leftPage);
  }

  get rightPageIndex(): number | null {
    return this.pageToIndex(this.rightPage);
  }

  get leftPageSrc(): string | null | undefined {
    if (this.leftPageIndex === null) return null;

    return this.catalog.pages[this.leftPageIndex].scan?.url;
  }

  get rightPageSrc(): string | null | undefined {
    if (this.rightPageIndex === null) return null;

    return this.catalog.pages[this.rightPageIndex].scan?.url;
  }

  get leftPageClass(): Record<string, boolean> {
    return {
      page: true,
      left: true,
      hidden: this.leftPageIndex === null,
    };
  }

  get rightPageClass(): Record<string, boolean> {
    return {
      page: true,
      right: true,
      hidden: this.rightPageIndex === null,
    };
  }
}
</script>

<style lang="scss">
.catalog-viewer {
  display: flex;
  flex-direction: row;
  // box-shadow: 0 10px 5px rgba(0, 0, 0.5, 0.3);

  .page {
    aspect-ratio: 1;
    flex-grow: 1;
    flex-basis: 0;

    &.left {
    }
    &.right {
    }
    &.hidden {
      visibility: hidden;
    }

    img {
      width: 100%;
      height: 100%;
      object-fit: contain;
    }
  }
}
</style>
